## holmes-3.4.1.tar.gz

=== Makefile ===
# Makefile for the Sherlock Search System
# (c) 1997--2004 Martin Mares <mj@ucw.cz>

TOPDIR:=$(shell pwd)

CFLAGS=$(CLANG) $(COPT) $(CDEBUG) $(CWARNS) -I. -Iobj
LDFLAGS=$(LOPT)

DIRS=
PROGS=
CONFIGS=accept filter sherlock local trace url-equiv
TESTS=

# Various files whose type does not fit into PROGS
DATAFILES=

.PHONY: all clean distclean runtree programs datafiles force tags config dust

all: runtree programs datafiles extras config

include sherlock/config.mk
-include custom/config.mk

custom/config.mk:
	@echo 'You need to link "custom" to the right directory.'
	@exit 1

ifdef CONFIG_SHARED
LS=so
OS=oo
else
LS=a
OS=o
endif

# Clean needs to be a double-colon rule since we want sub-makefiles to be able
# to define their own cleanup actions.
dust::
	rm -f `find . -path "*~" -or -name "\#*\#" -or -name core`
	rm -f allocs.tmp cscope.out test*.log

clean:: dust
	rm -rf obj run/bin/* run/lib/* run/.tree-stamp
	rm -f TAGS

distclean:: clean
	rm -rf run
	rm custom

testclean::
	rm -f `find obj -name "*.test"`

# Extra directories to be created in the run/* hierarchy
EXTRA_RUNDIRS=db tmp index lock log lib/perl5/Sherlock
INSTALL_RUNDIRS=bin lib

# Extra default rules (appended to by submakefiles)
extras::

# We need to define names of libraries here, because even though variable references
# in bodies of rules can be forward, those in dependencies cannot. Also the order of
# includes is somewhat fragile because of that.
LIBSH=obj/sherlock/libsh.$(LS) obj/lib/libucw.$(LS)
LIBCHARSET=obj/charset/libcharset.$(LS)
LIBFILTER=obj/filter/libfilter.$(LS)
ifdef CONFIG_LANG
LIBLANG=obj/lang/liblang.$(LS)
endif

# Include makefiles of various subsystems.
-include custom/Makefile
include build/Makefile
include sherlock/Makefile
include lib/Makefile
include charset/Makefile
include filter/Makefile
ifdef CONFIG_LANG
include lang/Makefile
endif
include utils/Makefile
include gather/Makefile
include indexer/Makefile
ifdef CONFIG_SEARCH
include search/Makefile
endif
ifdef CONFIG_DEBUG
include debug/Makefile
endif

runtree: run/.tree-stamp $(addsuffix /.dir-stamp,$(addprefix obj/,$(DIRS)))

run/.tree-stamp: custom/config.mk
	mkdir -p run $(addprefix run/, cf $(EXTRA_RUNDIRS) $(INSTALL_RUNDIRS))
	touch run/.tree-stamp

programs: $(PROGS)
datafiles: $(DATAFILES)
tests: $(TESTS)

tags:
	etags `find . -name "*.[ch]"`

# Generate configuration files

config: $(addprefix run/cf/,$(CONFIGS))

run/cf/%: custom/cf/% custom/config.mk build/genconf
	build/genconf $< $@ custom/config.mk
run/cf/%: cf/% custom/config.mk build/genconf
	build/genconf $< $@ custom/config.mk

# Black magic with dependencies. It would be more correct to make "depend.new"
# a prerequisite for "depend", but "depend.new" often has the same timestamp
# as "depend" which would confuse make a lot and either force remaking anyway
# or (as in current versions of GNU make) erroneously skipping the remaking.

-include obj/depend

obj/depend: force
	if [ -s obj/depend.new ] ; then build/mergedeps obj/depend obj/depend.new ; >obj/depend.new ; fi

force:

# Configuration

obj/lib/autoconf.h: sherlock/config.mk custom/config.mk
	cat $^ | sed '/^#/d; /^$$/d; s/\([^=]*_[^=]*\)=\(.*\)/#define \1 \2/; /^#/!d' >obj/lib/autoconf.h.new
	mv obj/lib/autoconf.h.new obj/lib/autoconf.h

# Installation

install: all
	SH_EXTRA_RUNDIRS="$(EXTRA_RUNDIRS)" SH_INSTALL_RUNDIRS="$(INSTALL_RUNDIRS)" SH_CONFIGS="$(CONFIGS)" build/installer $(INSTALL_DIR)

# Implicit rules

%.dir-stamp:
	mkdir -p $(@D) && touch $@

%.a:
	ar rcs $@ $?

%.so:
	$(CC) $(LSHARED) $(LDFLAGS) -o $@ $^
	ln -sf $(TOPDIR)/$@ run/lib

obj/%.o: %.c obj/lib/autoconf.h
	DEPENDENCIES_OUTPUT="obj/depend.new $@" $(CC) $(CFLAGS) -c -o $@ $<

obj/%.oo: %.c obj/lib/autoconf.h
	DEPENDENCIES_OUTPUT="obj/depend.new $@" $(CC) $(CFLAGS) $(CSHARED) -c -o $@ $<

obj/%-tt.o: %.c obj/lib/autoconf.h
	DEPENDENCIES_OUTPUT="obj/depend.new $@" $(CC) $(CFLAGS) -DTEST -c -o $@ $<

obj/%-t: obj/%-tt.o $(LIBSH)
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)

obj/%.test: %.t build/tester
	build/tester $< && touch $@

BINDIR=bin

obj/%: obj/%.o
	$(CC) $(LDFLAGS) -o $@ $^ $(LIBS)
	ln -sf $(TOPDIR)/$@ run/$(BINDIR)/

obj/%: %.sh custom/config.mk build/genconf
	build/genconf $< $@ custom/config.mk
	chmod +x $@
	ln -sf $(TOPDIR)/$@ run/$(BINDIR)/

obj/%: %.pl
	cp $(TOPDIR)/$^ $@
	chmod +x $@
	ln -sf $(TOPDIR)/$@ run/$(BINDIR)/

obj/%.pm: %.pm
	cp $(TOPDIR)/$^ $@
	ln -sf $(TOPDIR)/$@ run/lib/perl5/Sherlock

DATADIR=lib

$(DATAFILES): obj/%: %
	cp $(TOPDIR)/$^ $@
	ln -sf $(TOPDIR)/$@ run/$(DATADIR)/

# Don't delete intermediate targets. There shouldn't be any, but due to bugs
# in GNU Make rules with targets in not-yet-existing directories are ignored
# when searching for implicit rules and thence targets considered intermediate.
.SECONDARY:

=== bare/Makefile ===
# Stub Makefile for custom modules in the bare version of Sherlock

=== build/Makefile ===
# Makefile for Sherlock Build Tools

DIRS+=build

obj/build/genhash: obj/build/genhash.o

=== charset/Makefile ===
# Makefile for the Sherlock Charset Library (c) 1997--2002 Martin Mares <mj@ucw.cz>

DIRS+=charset

LIBCHARSET_MODS=toupper tolower tocat toligatures unaccent charconv setnames fb-charconv

obj/charset/libcharset.a: $(addsuffix .o,$(addprefix obj/charset/,$(LIBCHARSET_MODS)))
obj/charset/libcharset.so: $(addsuffix .oo,$(addprefix obj/charset/,$(LIBCHARSET_MODS)))

build_charsets:
	cd charset && sh misc/generate

clean::
	rm -f charset/misc/u-*

=== debug/Makefile ===
# Debugging utilities which are intended solely for authors' internal use

DIRS+=debug
PROGS+=$(addprefix obj/debug/,whenis sample cols)

obj/debug/random-access: obj/debug/random-access.o $(LIBSH)
obj/debug/sample: obj/debug/sample.o $(LIBSH)
obj/debug/flashdis: obj/debug/flashdis.o $(LIBSH)
obj/debug/refs-analyse: obj/debug/refs-analyse.o obj/indexer/iconfig.o $(LIBSH) -lm

=== filter/Makefile ===
# Makefile for the Sherlock Filter Language (c) 2001--2003 Martin Mares <mj@ucw.cz>

DIRS+=filter
PROGS+=obj/filter/filter-test

LIBFILTER_MODS=lex parse.tab filter prune builtin hashes tries trees dumper fconfig

obj/filter/libfilter.a: $(addsuffix .o,$(addprefix obj/filter/,$(LIBFILTER_MODS)) $(CUSTOM_FILTER_MODULES))
obj/filter/libfilter.so: $(addsuffix .oo,$(addprefix obj/filter/,$(LIBFILTER_MODS)) $(CUSTOM_FILTER_MODULES))

obj/filter/ftest: obj/filter/ftest.o $(LIBFILTER) $(LIBSH)
obj/filter/filter-test: obj/filter/filter-test.o $(LIBFILTER) $(LIBSH)

obj/filter/parse.tab.o obj/filter/parse.tab.oo: CWARNS+=-Wno-sign-compare -Wno-redundant-decls -Wno-undef
obj/filter/lex.o obj/filter/lex.oo: CWARNS+=-Wno-redundant-decls -Wno-missing-prototypes -Wno-unused-function -Wno-undef

$(addsuffix .o,$(addprefix obj/filter/,$(LIBFILTER_MODS))) \
$(addsuffix .oo,$(addprefix obj/filter/,$(LIBFILTER_MODS))): filter/parse.tab.h

filter/parse.tab.h: filter/parse.tab.c
	touch $@

filter/parse.tab.c: filter/parse.y
	bison -dv $^ -o $@

filter/lex.c: filter/lex.l
	flex -s -B -8 -o$@ $^

dust::
	cd filter && rm -f parse.tab.[ch] parse.output lex.c

=== free/Makefile ===
# Stub Makefile for custom modules in the free version of Sherlock

CONFIGS+=timetable

include free/filter/Makefile
include free/lib/Makefile

=== gather/Makefile ===
# Makefile for the Sherlock Gatherer (c) 2001--2004 Martin Mares <mj@ucw.cz>

DIRS+=gather

ifdef CONFIG_GATHERER

PROGS+=obj/gather/gtest obj/gather/gbatch
CONFIGS+=checker checker-filter

LIBGATH_MODS=gobject gconfig charset content gfilter
LIBGATH_LIBS=-lz
LIBGATH=obj/gather/libgather.$(LS)

include gather/proto/Makefile
include gather/format/Makefile

obj/gather/libgather.a: $(addsuffix .o,$(addprefix obj/gather/,$(LIBGATH_MODS)))
obj/gather/libgather.so: $(addsuffix .oo,$(addprefix obj/gather/,$(LIBGATH_MODS)))

obj/gather/gtest: obj/gather/gtest.o $(LIBGATH) $(LIBFILTER) $(LIBCHARSET) $(LIBSH)
obj/gather/gtest: LIBS+=$(LIBGATH_LIBS)

obj/gather/gbatch: obj/gather/gbatch.o $(LIBGATH) $(LIBFILTER) $(LIBCHARSET) $(LIBSH)
obj/gather/gbatch: LIBS+=$(LIBGATH_LIBS)

ifdef CONFIG_GATHERD
include gather/daemon/Makefile
endif

endif

=== indexer/Makefile ===
# Makefile for the Sherlock Indexer (c) 2001--2004 Martin Mares <mj@ucw.cz>

DIRS+=indexer

ifdef CONFIG_INDEXER

PROGS+=$(addprefix obj/indexer/,indexer scanner merger labelsort mklex \
chewer wsort ssort psort lexorder lexsort lexfreq seal)

ifndef CONFIG_BARE
PROGS+=$(addprefix obj/indexer/,mergesums mergesigns keywords mergefp ireport reftexts \
backlinker mkgraph fpsort)
endif

endif

obj/indexer/scanner: obj/indexer/scanner.o obj/indexer/iconfig.o obj/indexer/matcher.o obj/indexer/alphabet.o obj/indexer/lexicon.o \
	obj/indexer/getbuck.o $(LIBFILTER) $(LIBLANG) $(LIBCHARSET) $(LIBSH)
obj/indexer/scanner: LIBS+=$(LIBLANG_LIBS)
obj/indexer/mergefp: obj/indexer/mergefp.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/mergesums: obj/indexer/mergesums.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/mergesigns: obj/indexer/mergesigns.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/fpsort: obj/indexer/fpsort.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/merger: obj/indexer/merger.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/labelsort: obj/indexer/labelsort.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/mklex: obj/indexer/mklex.o obj/indexer/lexicon.o obj/indexer/alphabet.o obj/indexer/iconfig.o obj/indexer/fetch.o \
	obj/indexer/getbuck.o $(LIBFILTER) $(LIBCHARSET) $(LIBSH)
obj/indexer/chewer: obj/indexer/chewer.o obj/indexer/lexicon.o obj/indexer/alphabet.o obj/indexer/iconfig.o obj/indexer/fetch.o \
	obj/indexer/getbuck.o $(LIBFILTER) $(LIBCHARSET) $(LIBSH)
obj/indexer/wsort: obj/indexer/wsort.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/ssort: obj/indexer/ssort.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/psort: obj/indexer/psort.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/mkgraph: obj/indexer/mkgraph.o obj/indexer/resolve.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/backlinker: obj/indexer/backlinker.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/reftexts: obj/indexer/reftexts.o obj/indexer/iconfig.o obj/indexer/resolve.o $(LIBCHARSET) $(LIBSH)
obj/indexer/reftexts: LIBS+=-lm
obj/indexer/lexmap-test: obj/indexer/lexmap-test.o obj/indexer/lexicon.o obj/indexer/alphabet.o $(LIBCHARSET) $(LIBSH)
obj/indexer/lexorder: obj/indexer/lexorder.o obj/indexer/iconfig.o obj/indexer/lexicon.o $(LIBLANG) $(LIBCHARSET) $(LIBSH)
obj/indexer/lexorder: LIBS+=$(LIBLANG_LIBS) -lm
obj/indexer/lexsort: obj/indexer/lexsort.o obj/indexer/iconfig.o obj/indexer/lexicon.o $(LIBCHARSET) $(LIBSH)
obj/indexer/lexfreq: obj/indexer/lexfreq.o obj/indexer/iconfig.o $(LIBSH)
obj/indexer/ireport: obj/indexer/ireport.o obj/indexer/iconfig.o $(LIBLANG) $(LIBCHARSET) $(LIBSH)
obj/indexer/ireport: LIBS+=$(LIBLANG_LIBS)
obj/indexer/keywords: obj/indexer/keywords.o obj/indexer/lexicon.o obj/indexer/alphabet.o obj/indexer/iconfig.o $(LIBCHARSET) $(LIBSH)
obj/indexer/seal: obj/indexer/seal.o obj/indexer/iconfig.o $(LIBSH)

obj/indexer/getbuck-t: obj/indexer/getbuck-tt.o obj/indexer/iconfig.o $(LIBSH)

=== lang/Makefile ===
# Makefile for the Sherlock Language Processing Modules (c) 2003--2005 Martin Mares <mj@ucw.cz>

DIRS+=lang
PROGS+=obj/lang/lang-tables obj/lang/stem-table-gen obj/lang/stemtest
CONFIGS+=lang-detect

LIBLANG_MODS=lang stemmer stem-porter stem-table detect kmp syndict

obj/lang/liblang.a: $(addsuffix .o,$(addprefix obj/lang/,$(LIBLANG_MODS)) $(LIBLANG_EXTRAS))
obj/lang/liblang.so: $(addsuffix .oo,$(addprefix obj/lang/,$(LIBLANG_MODS)) $(LIBLANG_EXTRAS))

obj/lang/stemtest: obj/lang/stemtest.o $(LIBLANG) $(LIBCHARSET) $(LIBSH)
obj/lang/stemtest: LIBS+=$(LIBLANG_LIBS)
obj/lang/lang-tables: obj/lang/lang-tables.o obj/indexer/getbuck.o obj/indexer/iconfig.o $(LIBFILTER) $(LIBLANG) $(LIBCHARSET) $(LIBSH)
obj/lang/lang-tables: LIBS+=$(LIBLANG_LIBS)
obj/lang/stem-table-gen: obj/lang/stem-table-gen.o $(LIBSH)

=== lib/Makefile ===
# Makefile for the UCW Library (c) 1997--2004 Martin Mares <mj@ucw.cz>

DIRS+=lib

ifdef CONFIG_UCW_DBTOOL
PROGS+=obj/lib/db-tool
endif

LIBUCW_MODS= \
	alloc alloc_str realloc mempool mempool-str \
	mmap pagecache partmap hashfunc \
	lists sorter bitsig \
	log log-file proctitle \
	conf ipaccess \
	profile \
	fastbuf ff-printf ff-utf8 \
	fb-file carefulio fb-mem fb-temp fb-mmap fb-limfd fb-buffer \
	str_ctype str_upper str_lower unicode-utf8 \
	wildmatch wordsplit ctmatch patimatch patmatch regex \
	prime random timer log2 randomkey \
	db \
	url \
	mainloop exitstatus runcmd sighandler \
	lizard lizard-safe adler32 \
	md5 md5hex \
	base64 base224 \
	sync

ifdef CONFIG_OWN_REGEX
include lib/regex/Makefile
endif

LIBUCW=obj/lib/libucw.$(LS)
LIBUCW_MOD_PATHS=$(addprefix obj/lib/,$(LIBUCW_MODS))

obj/lib/libucw.a: $(addsuffix .o,$(LIBUCW_MOD_PATHS))
obj/lib/libucw.so: $(addsuffix .oo,$(LIBUCW_MOD_PATHS))

obj/lib/hashfunc.o obj/lib/hashfunc.oo: CFLAGS += -funroll-loops
obj/lib/lizard.o: CFLAGS += -O6 -funroll-loops

obj/lib/db-test: obj/lib/db-test.o $(LIBUCW)
obj/lib/db-tool: obj/lib/db-tool.o $(LIBUCW)
obj/lib/conf-test: obj/lib/conf-test.o $(LIBUCW)
obj/lib/sort-test: obj/lib/sort-test.o $(LIBUCW)
obj/lib/lfs-test: obj/lib/lfs-test.o $(LIBUCW)
obj/lib/hash-test: obj/lib/hash-test.o $(LIBUCW)
obj/lib/str-test: obj/lib/str-test.o $(LIBUCW)
obj/lib/asort-test: obj/lib/asort-test.o $(LIBUCW)
obj/lib/redblack-test: obj/lib/redblack-test.o $(LIBUCW)
obj/lib/binheap-test: obj/lib/binheap-test.o $(LIBUCW)
obj/lib/lizard-test: obj/lib/lizard-test.o $(LIBUCW)

TESTS+=$(addprefix obj/lib/,regex.test unicode-utf8.test hash-test.test)
obj/lib/regex.test: obj/lib/regex-t
obj/lib/unicode-utf8.test: obj/lib/unicode-utf8-t
obj/lib/hash-test.test: obj/lib/hash-test

ifdef CONFIG_UCW_PERL
include lib/perl/Makefile
endif

ifdef CONFIG_UCW_SHELL_UTILS
include lib/shell/Makefile
endif

=== search/Makefile ===
# Makefile for the Sherlock Search Server (c) 2001--2004 Martin Mares <mj@ucw.cz>

DIRS+=search
PROGS+=obj/search/sherlockd

SS_OBJS=sherlockd.o config.o dbase.o reply.o query.o lex.o parse.tab.o cards.o words.o strings.o memory.o refs.o cmds.o

obj/search/sherlockd: $(addprefix obj/search/,$(SS_OBJS)) obj/indexer/alphabet.o $(LIBLANG) $(LIBCHARSET) $(LIBSH)
obj/search/sherlockd: LIBS+=$(LIBLANG_LIBS)

obj/search/lex.o: search/parse.tab.h
obj/search/parse.tab.o obj/search/parse.tab.oo: CWARNS+=-Wno-sign-compare -Wno-redundant-decls -Wno-undef

search/parse.tab.h: search/parse.tab.c
	touch $@

search/parse.tab.c: search/parse.y
	bison -dv $^ -o $@

dust::
	cd search && rm -f parse.tab.[ch] parse.output

=== debian/changelog ===
holmes (3.4.1) stable; urgency=high

  * An essential bugfix in the gatherer concerning compressed buckets.

 -- Robert Spalek <robert@ucw.cz>  Wed, 23 Feb 2005 17:30:00 +0100

holmes (3.4) stable; urgency=low

  * License changed from proprietary to GPL!  The free version is hence no
    longer limited to 100k documents.

  Major new features and changes:

  * Buckets and cards are now stored in a new format designed for fast
    zero-copy processing.  Moreover, the gatherer and the indexer can compress
    the bucket file and cards using an included very fast compression library
    LiZaRd, saving about 30% of their size.
  * A lot of optimization work has been done, especially in the following
    modules: general sorter, bucket shakedown, computation of signatures, and
    chewer.  The usage of regular expressions at time-critical places (URL
    keywords recognition and testing session id's) has been abandoned in
    favour of hard-encoded C-routines; the speedup is about 10x.  The memory
    requirements of indexer have been decreased, and a partial sorting (with
    some more seeking afterwards) is used where appropriate.  The whole
    Sherlock has scaled up; we have successfully used it on 70M documents.
  * Texts of HTML links (reference texts) can now be indexed together with the
    text of a page.  They are attached at the end of the card together with
    the URL of the referring page.
  * Big cleanup in the customization interface; see doc/changes.  A new "bare"
    customization (as simple as possible) added.  Introduced late matchers,
    custom matchers, and custom statistics.  You can define your own filter
    functions.

  Minor new features and changes:

  * Gatherer:
    o HTML parser recognizes inline META robot control tags and it implements
      the new "rel=nofollow" attribute in tags containing links.  It also
      tries to avoid duplicate ALT and TITLE reference texts.
    o PDF parser supports new encryption formats.  Added a pdfdump utility for
      debugging.  Several problematic PDF documents are parsed correcly now.
      The parser has been split into a few modules and cleaned up.
    o Computation of a queue key (QKEY) works properly even for hosts with
      multiple IP-addresses.
    o Refreshing of documents is improved; we now check the differences
      against the original version before storing the new version.
    o The new charset guesser is more resistant against a few characters in a
      different charset inserted in the middle of the page (such as banner
      texts).  Content-type guesser logic is improved, too.
    o Added charset recognizer configuration for the Polish language.
    o Conformance to standards improved (URL's, HTTP protocol), but we also
      try to be more tolerant to others breaking the standards (especially in
      date parsing).
    o When a filter tries to reject downloading of robots.txt, its decision is
      ignored. Otherwise all sorts of strange things happen.

  * Indexer:
    o Indexer can now generate an index from a plain text file with buckets
      separated by an empty line instead of a bucket-file.
    o Several common singletons (such as & and +) added as context words.
    o Changed the format of the attributes file: file-type and language bits
      redistributed.
    o ireport reports filetype, language, and domain statistics.

  * Search server:
    o Search server can search on multiple indices, which are merged on-line.
    o Added a new CONTEXT FULL mode which dumps all the text we remember.
    o Added a sort mode which only sorts on a given attribute, but it ignores
      the Q-factor.
    o Added a hydra mode for SMP-systems, where several concurrent processes
      are run.
    o Fixed calculation of the 2nd best match.
    o Important bugfixes: no more stack overflows and SIGBUS's.
    o The example front-end works again.

  * Optimizations:
    o Several regular expression backends supported and one of them (known to
      be _relatively_ stable and fast) engine imported to the source tree and
      it is set as default.  However, as said above, we do not trust it anough
      and rather rewrote some tests into C.
    o Filters: Added a new interval test: if (a =# 1 .. 10).  Switch commands
      consisting of == and =# tests are optimized to logarithmic complexity
      using red-black binary search trees.  We also added a new general
      utility for testing filters in various modes.

  * Cleanups:
    o Major cleanup of all libraries. The old `libsh' has been split to a fairly
      generic `libucw' and parts specific for Holmes.  The charset library has
      been almost rewritten.
    o Cleanup of makefiles and configuration files.  The build system no longer
      writes into the source directories.
    o Numbers in configuration files can be specified in various units.
    o Improved and optimized debugging utilities (buckettool, idxdump, and
      dump-card).
    o All daemons create their locks files in a special lock-directory.
    o Added a brief introduction to the coding style (doc/codingstyle).
    o Added an automatic unit-testing framework (try `make tests').
    o Watson rewritten.

  * Other important issues:
    o Bugfix for some (especially Fedora) kernels: Sherlock now copes with
      pointers close to the 4GB limit.
    o Building of shared libraries now uses `gcc -shared' instead of talking
      directly with the linker, making shared libraries work on newer systems.

  * As usual, we have done many more bugfixes, optimizations, cleanups, and
    code polishing.

 -- Robert Spalek <robert@ucw.cz>  Tue, 22 Feb 2005 15:27:00 +0100

holmes (2.6.2) stable; urgency=low

  * Released a parser for PDF documents, previously only available in
    the commercial version.

 -- Martin Mares <mj@ucw.cz>  Sun,  8 Feb 2004 17:15:34 +0100

holmes (2.6.1) stable; urgency=low

  * Released as stable version, no changes against -beta2.



=== debian/control ===
Source: holmes
Section: non-free/text
Priority: extra
Maintainer: Robert Spalek <robert@ucw.cz>
Standards-Version: 3.5.6.1
Build-Depends: perl, zlib1g-dev

Package: holmes
Architecture: any
Depends: perl (>= 5.6), ${shlibs:Depends}
Suggests: gnuplot
Description: Universal Search Engine
 A freely distributable version of the Sherlock Holmes search engine -- a
 system for gathering and indexing of textual data (text files, web pages,
 ...), both locally and over the network.

=== debian/rules ===
#!/usr/bin/make -f
# Rules for building of Sherlock Holmes Debian/non-free/text Package
# (c) 1999 Martin Mares <mj@ucw.cz>
# (c) 2002 Robert Spalek <robert@ucw.cz>

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-stamp
build-stamp:
	dh_testdir
	$(MAKE)
	touch build-stamp

clean:
	dh_testdir
	#dh_testroot
	rm -f build-stamp
	$(MAKE) distclean
	dh_clean

binary-indep: build

binary-arch: build
	dh_testdir
	#dh_testroot
	dh_clean -k
	dh_installdirs etc/holmes usr/lib/holmes/bin usr/lib/holmes/lib usr/bin
	dh_installdirs usr/lib/perl5/Sherlock usr/lib/holmes/front-end

	install -m 644 cf/[a-z]* debian/tmp/etc/holmes
	install -m 755 run/bin/* debian/tmp/usr/lib/holmes/bin
	install -m 755 run/lib/*.so debian/tmp/usr/lib/holmes/lib
	install -m 755 debian/holmes-instantiate debian/tmp/usr/bin
	install -m 644 run/lib/perl5/Sherlock/* debian/tmp/usr/lib/perl5/Sherlock
	install -m 755 free/front-end/* debian/tmp/usr/lib/holmes/front-end

	dh_installdocs doc/* README
#	dh_installexamples
#	dh_installmenu
#	dh_installinit
#	dh_installcron
#	dh_installmanpages
	dh_undocumented holmes.1
	dh_installchangelogs
	dh_strip
#	dh_compress
	dh_fixperms
#	dh_suidregister
	dh_installdeb
	dh_shlibdeps
#	db_makeshlibs
	dh_gencontrol
#	dh_makeshlibs
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

get-orig-source:
	lynx -source http://www.ucw.cz/holmes/download/holmes-latest.deb

.PHONY: build clean binary-indep binary-arch binary get-orig-source
